﻿namespace Ggd.Splorr.Gadabout.MGClient

module DisplayPatterns =
    open Microsoft.Xna.Framework
    open Microsoft.Xna.Framework.Graphics
    open Ggd.Splorr.Gadabout

    let private toTextureArray (bytes:byte list) : Color array =
        let bitFlags = [1uy;2uy;4uy;8uy;16uy;32uy;64uy;128uy]
        bytes
        |> List.map(fun b -> bitFlags |> List.map (fun f-> if (f &&& b) > 0uy then Color.White else new Color(Color.Black,0)))
        |> List.reduce List.append
        |> Array.ofList

    let patterns = 
        [(Pattern.Character00,[0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character01,[126uy; 129uy; 165uy; 129uy; 189uy; 153uy; 129uy; 126uy]);
        (Pattern.Character02,[126uy; 255uy; 219uy; 255uy; 195uy; 231uy; 255uy; 126uy]);
        (Pattern.Character03,[54uy; 127uy; 127uy; 127uy; 62uy; 28uy; 8uy; 0uy]);
        (Pattern.Character04,[8uy; 28uy; 62uy; 127uy; 62uy; 28uy; 8uy; 0uy]);
        (Pattern.Character05,[28uy; 62uy; 28uy; 127uy; 127uy; 73uy; 8uy; 62uy]);
        (Pattern.Character06,[0uy; 8uy; 28uy; 62uy; 127uy; 62uy; 28uy; 62uy]);
        (Pattern.Character07,[0uy; 0uy; 24uy; 60uy; 60uy; 24uy; 0uy; 0uy]);
        (Pattern.Character08,[255uy; 255uy; 231uy; 195uy; 195uy; 231uy; 255uy; 255uy]);
        (Pattern.Character09,[0uy; 60uy; 102uy; 66uy; 66uy; 102uy; 60uy; 0uy]);
        (Pattern.Character0A,[255uy; 195uy; 153uy; 189uy; 189uy; 153uy; 195uy; 255uy]);
        (Pattern.Character0B,[240uy; 224uy; 240uy; 190uy; 51uy; 51uy; 51uy; 30uy]);
        (Pattern.Character0C,[60uy; 102uy; 102uy; 102uy; 60uy; 24uy; 126uy; 24uy]);
        (Pattern.Character0D,[252uy; 204uy; 252uy; 12uy; 12uy; 14uy; 15uy; 7uy]);
        (Pattern.Character0E,[254uy; 198uy; 254uy; 198uy; 198uy; 230uy; 103uy; 3uy]);
        (Pattern.Character0F,[153uy; 90uy; 60uy; 231uy; 231uy; 60uy; 90uy; 153uy]);
        (Pattern.Character10,[1uy; 7uy; 31uy; 127uy; 31uy; 7uy; 1uy; 0uy]);
        (Pattern.Character11,[64uy; 112uy; 124uy; 127uy; 124uy; 112uy; 64uy; 0uy]);
        (Pattern.Character12,[24uy; 60uy; 126uy; 24uy; 24uy; 126uy; 60uy; 24uy]);
        (Pattern.Character13,[102uy; 102uy; 102uy; 102uy; 102uy; 0uy; 102uy; 0uy]);
        (Pattern.Character14,[254uy; 219uy; 219uy; 222uy; 216uy; 216uy; 216uy; 0uy]);
        (Pattern.Character15,[124uy; 198uy; 28uy; 54uy; 54uy; 28uy; 97uy; 63uy]);
        (Pattern.Character16,[0uy; 0uy; 0uy; 0uy; 126uy; 126uy; 126uy; 0uy]);
        (Pattern.Character17,[24uy; 60uy; 126uy; 24uy; 126uy; 60uy; 24uy; 255uy]);
        (Pattern.Character18,[24uy; 60uy; 126uy; 24uy; 24uy; 24uy; 24uy; 0uy]);
        (Pattern.Character19,[24uy; 24uy; 24uy; 24uy; 126uy; 60uy; 24uy; 0uy]);
        (Pattern.Character1A,[0uy; 24uy; 48uy; 127uy; 48uy; 24uy; 0uy; 0uy]);
        (Pattern.Character1B,[0uy; 12uy; 6uy; 127uy; 6uy; 12uy; 0uy; 0uy]);
        (Pattern.Character1C,[0uy; 0uy; 3uy; 3uy; 3uy; 127uy; 0uy; 0uy]);
        (Pattern.Character1D,[0uy; 36uy; 102uy; 255uy; 102uy; 36uy; 0uy; 0uy]);
        (Pattern.Character1E,[0uy; 24uy; 60uy; 126uy; 255uy; 255uy; 0uy; 0uy]);
        (Pattern.Character1F,[0uy; 255uy; 255uy; 126uy; 60uy; 24uy; 0uy; 0uy]);
        (Pattern.Character20,[0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character21,[24uy; 60uy; 60uy; 24uy; 24uy; 0uy; 24uy; 0uy]);
        (Pattern.Character22,[54uy; 54uy; 54uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character23,[54uy; 54uy; 127uy; 54uy; 127uy; 54uy; 54uy; 0uy]);
        (Pattern.Character24,[24uy; 126uy; 3uy; 62uy; 96uy; 63uy; 24uy; 0uy]);
        (Pattern.Character25,[0uy; 99uy; 51uy; 24uy; 12uy; 102uy; 99uy; 0uy]);
        (Pattern.Character26,[28uy; 54uy; 28uy; 110uy; 59uy; 51uy; 110uy; 0uy]);
        (Pattern.Character27,[12uy; 12uy; 6uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character28,[24uy; 12uy; 6uy; 6uy; 6uy; 12uy; 24uy; 0uy]);
        (Pattern.Character29,[6uy; 12uy; 24uy; 24uy; 24uy; 12uy; 6uy; 0uy]);
        (Pattern.Character2A,[0uy; 102uy; 60uy; 255uy; 60uy; 102uy; 0uy; 0uy]);
        (Pattern.Character2B,[0uy; 24uy; 24uy; 126uy; 24uy; 24uy; 0uy; 0uy]);
        (Pattern.Character2C,[0uy; 0uy; 0uy; 0uy; 0uy; 24uy; 24uy; 12uy]);
        (Pattern.Character2D,[0uy; 0uy; 0uy; 126uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character2E,[0uy; 0uy; 0uy; 0uy; 0uy; 24uy; 24uy; 0uy]);
        (Pattern.Character2F,[96uy; 48uy; 24uy; 12uy; 6uy; 3uy; 1uy; 0uy]);
        (Pattern.Character30,[62uy; 99uy; 107uy; 107uy; 107uy; 99uy; 62uy; 0uy]);
        (Pattern.Character31,[12uy; 14uy; 12uy; 12uy; 12uy; 12uy; 63uy; 0uy]);
        (Pattern.Character32,[30uy; 51uy; 48uy; 28uy; 6uy; 51uy; 63uy; 0uy]);
        (Pattern.Character33,[30uy; 51uy; 48uy; 28uy; 48uy; 51uy; 30uy; 0uy]);
        (Pattern.Character34,[56uy; 60uy; 54uy; 51uy; 127uy; 48uy; 120uy; 0uy]);
        (Pattern.Character35,[63uy; 3uy; 31uy; 48uy; 48uy; 51uy; 30uy; 0uy]);
        (Pattern.Character36,[28uy; 6uy; 3uy; 31uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character37,[63uy; 51uy; 48uy; 24uy; 12uy; 12uy; 12uy; 0uy]);
        (Pattern.Character38,[30uy; 51uy; 51uy; 30uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character39,[30uy; 51uy; 51uy; 62uy; 48uy; 24uy; 14uy; 0uy]);
        (Pattern.Character3A,[0uy; 24uy; 24uy; 0uy; 0uy; 24uy; 24uy; 0uy]);
        (Pattern.Character3B,[0uy; 24uy; 24uy; 0uy; 0uy; 24uy; 24uy; 12uy]);
        (Pattern.Character3C,[24uy; 12uy; 6uy; 3uy; 6uy; 12uy; 24uy; 0uy]);
        (Pattern.Character3D,[0uy; 0uy; 126uy; 0uy; 126uy; 0uy; 0uy; 0uy]);
        (Pattern.Character3E,[6uy; 12uy; 24uy; 48uy; 24uy; 12uy; 6uy; 0uy]);
        (Pattern.Character3F,[60uy; 102uy; 48uy; 24uy; 24uy; 0uy; 24uy; 0uy]);
        (Pattern.Character40,[62uy; 99uy; 123uy; 123uy; 59uy; 3uy; 62uy; 0uy]);
        (Pattern.Character41,[12uy; 30uy; 51uy; 51uy; 63uy; 51uy; 51uy; 0uy]);
        (Pattern.Character42,[63uy; 102uy; 102uy; 62uy; 102uy; 102uy; 63uy; 0uy]);
        (Pattern.Character43,[60uy; 102uy; 3uy; 3uy; 3uy; 102uy; 60uy; 0uy]);
        (Pattern.Character44,[31uy; 54uy; 102uy; 102uy; 102uy; 54uy; 31uy; 0uy]);
        (Pattern.Character45,[127uy; 70uy; 22uy; 30uy; 22uy; 70uy; 127uy; 0uy]);
        (Pattern.Character46,[127uy; 70uy; 22uy; 30uy; 22uy; 6uy; 15uy; 0uy]);
        (Pattern.Character47,[60uy; 102uy; 3uy; 3uy; 115uy; 102uy; 92uy; 0uy]);
        (Pattern.Character48,[51uy; 51uy; 51uy; 63uy; 51uy; 51uy; 51uy; 0uy]);
        (Pattern.Character49,[30uy; 12uy; 12uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character4A,[120uy; 48uy; 48uy; 48uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character4B,[103uy; 102uy; 54uy; 30uy; 54uy; 102uy; 103uy; 0uy]);
        (Pattern.Character4C,[15uy; 6uy; 6uy; 6uy; 70uy; 102uy; 127uy; 0uy]);
        (Pattern.Character4D,[99uy; 119uy; 127uy; 127uy; 107uy; 99uy; 99uy; 0uy]);
        (Pattern.Character4E,[99uy; 103uy; 111uy; 123uy; 115uy; 99uy; 99uy; 0uy]);
        (Pattern.Character4F,[28uy; 54uy; 99uy; 99uy; 99uy; 54uy; 28uy; 0uy]);
        (Pattern.Character50,[63uy; 102uy; 102uy; 62uy; 6uy; 6uy; 15uy; 0uy]);
        (Pattern.Character51,[62uy; 99uy; 99uy; 99uy; 107uy; 62uy; 112uy; 0uy]);
        (Pattern.Character52,[63uy; 102uy; 102uy; 62uy; 54uy; 102uy; 103uy; 0uy]);
        (Pattern.Character53,[62uy; 99uy; 7uy; 30uy; 112uy; 99uy; 62uy; 0uy]);
        (Pattern.Character54,[63uy; 45uy; 12uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character55,[51uy; 51uy; 51uy; 51uy; 51uy; 51uy; 63uy; 0uy]);
        (Pattern.Character56,[51uy; 51uy; 51uy; 51uy; 51uy; 30uy; 12uy; 0uy]);
        (Pattern.Character57,[99uy; 99uy; 99uy; 99uy; 107uy; 127uy; 54uy; 0uy]);
        (Pattern.Character58,[99uy; 99uy; 54uy; 28uy; 54uy; 99uy; 99uy; 0uy]);
        (Pattern.Character59,[51uy; 51uy; 51uy; 30uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character5A,[127uy; 99uy; 49uy; 24uy; 76uy; 102uy; 127uy; 0uy]);
        (Pattern.Character5B,[30uy; 6uy; 6uy; 6uy; 6uy; 6uy; 30uy; 0uy]);
        (Pattern.Character5C,[3uy; 6uy; 12uy; 24uy; 48uy; 96uy; 64uy; 0uy]);
        (Pattern.Character5D,[30uy; 24uy; 24uy; 24uy; 24uy; 24uy; 30uy; 0uy]);
        (Pattern.Character5E,[8uy; 28uy; 54uy; 99uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character5F,[0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 255uy]);
        (Pattern.Character60,[12uy; 12uy; 24uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character61,[0uy; 0uy; 30uy; 48uy; 62uy; 51uy; 110uy; 0uy]);
        (Pattern.Character62,[7uy; 6uy; 6uy; 62uy; 102uy; 102uy; 59uy; 0uy]);
        (Pattern.Character63,[0uy; 0uy; 30uy; 51uy; 3uy; 51uy; 30uy; 0uy]);
        (Pattern.Character64,[56uy; 48uy; 48uy; 62uy; 51uy; 51uy; 110uy; 0uy]);
        (Pattern.Character65,[0uy; 0uy; 30uy; 51uy; 63uy; 3uy; 30uy; 0uy]);
        (Pattern.Character66,[28uy; 54uy; 38uy; 15uy; 6uy; 6uy; 15uy; 0uy]);
        (Pattern.Character67,[0uy; 0uy; 110uy; 51uy; 51uy; 62uy; 48uy; 31uy]);
        (Pattern.Character68,[7uy; 6uy; 54uy; 110uy; 102uy; 102uy; 103uy; 0uy]);
        (Pattern.Character69,[12uy; 0uy; 14uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character6A,[48uy; 0uy; 56uy; 48uy; 48uy; 51uy; 51uy; 30uy]);
        (Pattern.Character6B,[7uy; 6uy; 102uy; 54uy; 30uy; 54uy; 103uy; 0uy]);
        (Pattern.Character6C,[14uy; 12uy; 12uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character6D,[0uy; 0uy; 51uy; 127uy; 127uy; 107uy; 107uy; 0uy]);
        (Pattern.Character6E,[0uy; 0uy; 29uy; 51uy; 51uy; 51uy; 51uy; 0uy]);
        (Pattern.Character6F,[0uy; 0uy; 30uy; 51uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character70,[0uy; 0uy; 59uy; 102uy; 102uy; 62uy; 6uy; 15uy]);
        (Pattern.Character71,[0uy; 0uy; 110uy; 51uy; 51uy; 62uy; 48uy; 120uy]);
        (Pattern.Character72,[0uy; 0uy; 59uy; 110uy; 70uy; 6uy; 15uy; 0uy]);
        (Pattern.Character73,[0uy; 0uy; 62uy; 3uy; 14uy; 56uy; 31uy; 0uy]);
        (Pattern.Character74,[8uy; 12uy; 63uy; 12uy; 12uy; 44uy; 24uy; 0uy]);
        (Pattern.Character75,[0uy; 0uy; 51uy; 51uy; 51uy; 51uy; 110uy; 0uy]);
        (Pattern.Character76,[0uy; 0uy; 51uy; 51uy; 51uy; 30uy; 12uy; 0uy]);
        (Pattern.Character77,[0uy; 0uy; 99uy; 99uy; 107uy; 127uy; 54uy; 0uy]);
        (Pattern.Character78,[0uy; 0uy; 99uy; 54uy; 28uy; 54uy; 99uy; 0uy]);
        (Pattern.Character79,[0uy; 0uy; 51uy; 51uy; 51uy; 62uy; 48uy; 31uy]);
        (Pattern.Character7A,[0uy; 0uy; 63uy; 25uy; 12uy; 38uy; 63uy; 0uy]);
        (Pattern.Character7B,[56uy; 12uy; 12uy; 7uy; 12uy; 12uy; 56uy; 0uy]);
        (Pattern.Character7C,[24uy; 24uy; 24uy; 0uy; 24uy; 24uy; 24uy; 0uy]);
        (Pattern.Character7D,[7uy; 12uy; 12uy; 56uy; 12uy; 12uy; 7uy; 0uy]);
        (Pattern.Character7E,[110uy; 59uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Character7F,[0uy; 8uy; 28uy; 54uy; 99uy; 99uy; 127uy; 0uy]);
        (Pattern.Character80,[62uy; 99uy; 3uy; 99uy; 62uy; 48uy; 96uy; 62uy]);
        (Pattern.Character81,[0uy; 51uy; 0uy; 51uy; 51uy; 51uy; 110uy; 0uy]);
        (Pattern.Character82,[56uy; 0uy; 30uy; 51uy; 63uy; 3uy; 30uy; 0uy]);
        (Pattern.Character83,[126uy; 129uy; 60uy; 96uy; 124uy; 102uy; 220uy; 0uy]);
        (Pattern.Character84,[51uy; 0uy; 30uy; 48uy; 62uy; 51uy; 110uy; 0uy]);
        (Pattern.Character85,[7uy; 0uy; 30uy; 48uy; 62uy; 51uy; 110uy; 0uy]);
        (Pattern.Character86,[12uy; 12uy; 30uy; 48uy; 62uy; 51uy; 110uy; 0uy]);
        (Pattern.Character87,[0uy; 0uy; 62uy; 99uy; 3uy; 30uy; 48uy; 28uy]);
        (Pattern.Character88,[126uy; 129uy; 60uy; 102uy; 126uy; 6uy; 60uy; 0uy]);
        (Pattern.Character89,[51uy; 0uy; 30uy; 51uy; 63uy; 3uy; 30uy; 0uy]);
        (Pattern.Character8A,[7uy; 0uy; 30uy; 51uy; 63uy; 3uy; 30uy; 0uy]);
        (Pattern.Character8B,[51uy; 0uy; 14uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character8C,[62uy; 65uy; 28uy; 24uy; 24uy; 24uy; 60uy; 0uy]);
        (Pattern.Character8D,[7uy; 0uy; 14uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.Character8E,[99uy; 8uy; 62uy; 99uy; 127uy; 99uy; 99uy; 0uy]);
        (Pattern.Character8F,[12uy; 12uy; 0uy; 30uy; 51uy; 63uy; 51uy; 0uy]);
        (Pattern.Character90,[56uy; 0uy; 63uy; 6uy; 30uy; 6uy; 63uy; 0uy]);
        (Pattern.Character91,[0uy; 0uy; 254uy; 48uy; 254uy; 51uy; 254uy; 0uy]);
        (Pattern.Character92,[124uy; 54uy; 51uy; 127uy; 51uy; 51uy; 115uy; 0uy]);
        (Pattern.Character93,[30uy; 33uy; 0uy; 30uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character94,[0uy; 51uy; 0uy; 30uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character95,[0uy; 7uy; 0uy; 30uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character96,[30uy; 33uy; 0uy; 51uy; 51uy; 51uy; 110uy; 0uy]);
        (Pattern.Character97,[0uy; 7uy; 0uy; 51uy; 51uy; 51uy; 110uy; 0uy]);
        (Pattern.Character98,[0uy; 51uy; 0uy; 51uy; 51uy; 62uy; 48uy; 31uy]);
        (Pattern.Character99,[195uy; 24uy; 60uy; 102uy; 102uy; 60uy; 24uy; 0uy]);
        (Pattern.Character9A,[51uy; 0uy; 51uy; 51uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.Character9B,[24uy; 24uy; 126uy; 3uy; 3uy; 126uy; 24uy; 24uy]);
        (Pattern.Character9C,[28uy; 54uy; 38uy; 15uy; 6uy; 103uy; 63uy; 0uy]);
        (Pattern.Character9D,[51uy; 51uy; 30uy; 12uy; 63uy; 12uy; 63uy; 12uy]);
        (Pattern.Character9E,[31uy; 51uy; 51uy; 95uy; 99uy; 243uy; 99uy; 195uy]);
        (Pattern.Character9F,[112uy; 216uy; 24uy; 60uy; 24uy; 24uy; 27uy; 14uy]);
        (Pattern.CharacterA0,[56uy; 0uy; 30uy; 48uy; 62uy; 51uy; 110uy; 0uy]);
        (Pattern.CharacterA1,[28uy; 0uy; 14uy; 12uy; 12uy; 12uy; 30uy; 0uy]);
        (Pattern.CharacterA2,[0uy; 56uy; 0uy; 30uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.CharacterA3,[0uy; 56uy; 0uy; 51uy; 51uy; 51uy; 110uy; 0uy]);
        (Pattern.CharacterA4,[0uy; 31uy; 0uy; 29uy; 51uy; 51uy; 51uy; 0uy]);
        (Pattern.CharacterA5,[63uy; 0uy; 51uy; 55uy; 63uy; 59uy; 51uy; 0uy]);
        (Pattern.CharacterA6,[60uy; 54uy; 54uy; 124uy; 0uy; 126uy; 0uy; 0uy]);
        (Pattern.CharacterA7,[28uy; 54uy; 54uy; 28uy; 0uy; 62uy; 0uy; 0uy]);
        (Pattern.CharacterA8,[24uy; 0uy; 24uy; 24uy; 12uy; 102uy; 60uy; 0uy]);
        (Pattern.CharacterA9,[0uy; 0uy; 0uy; 63uy; 3uy; 3uy; 0uy; 0uy]);
        (Pattern.CharacterAA,[0uy; 0uy; 0uy; 63uy; 48uy; 48uy; 0uy; 0uy]);
        (Pattern.CharacterAB,[99uy; 51uy; 27uy; 108uy; 214uy; 67uy; 33uy; 240uy]);
        (Pattern.CharacterAC,[195uy; 99uy; 51uy; 219uy; 236uy; 182uy; 243uy; 192uy]);
        (Pattern.CharacterAD,[24uy; 0uy; 24uy; 24uy; 60uy; 60uy; 24uy; 0uy]);
        (Pattern.CharacterAE,[0uy; 204uy; 102uy; 51uy; 102uy; 204uy; 0uy; 0uy]);
        (Pattern.CharacterAF,[0uy; 51uy; 102uy; 204uy; 102uy; 51uy; 0uy; 0uy]);
        (Pattern.CharacterB0,[68uy; 17uy; 68uy; 17uy; 68uy; 17uy; 68uy; 17uy]);
        (Pattern.CharacterB1,[170uy; 85uy; 170uy; 85uy; 170uy; 85uy; 170uy; 85uy]);
        (Pattern.CharacterB2,[187uy; 238uy; 187uy; 238uy; 187uy; 238uy; 187uy; 238uy]);
        (Pattern.CharacterB3,[24uy; 24uy; 24uy; 24uy; 24uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterB4,[24uy; 24uy; 24uy; 24uy; 31uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterB5,[24uy; 24uy; 31uy; 24uy; 31uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterB6,[108uy; 108uy; 108uy; 108uy; 111uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterB7,[0uy; 0uy; 0uy; 0uy; 127uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterB8,[0uy; 0uy; 31uy; 24uy; 31uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterB9,[108uy; 108uy; 111uy; 96uy; 111uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterBA,[108uy; 108uy; 108uy; 108uy; 108uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterBB,[0uy; 0uy; 127uy; 96uy; 111uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterBC,[108uy; 108uy; 111uy; 96uy; 127uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterBD,[108uy; 108uy; 108uy; 108uy; 127uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterBE,[24uy; 24uy; 31uy; 24uy; 31uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterBF,[0uy; 0uy; 0uy; 0uy; 31uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterC0,[24uy; 24uy; 24uy; 24uy; 248uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterC1,[24uy; 24uy; 24uy; 24uy; 255uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterC2,[0uy; 0uy; 0uy; 0uy; 255uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterC3,[24uy; 24uy; 24uy; 24uy; 248uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterC4,[0uy; 0uy; 0uy; 0uy; 255uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterC5,[24uy; 24uy; 24uy; 24uy; 255uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterC6,[24uy; 24uy; 248uy; 24uy; 248uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterC7,[108uy; 108uy; 108uy; 108uy; 236uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterC8,[108uy; 108uy; 236uy; 12uy; 252uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterC9,[0uy; 0uy; 252uy; 12uy; 236uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterCA,[108uy; 108uy; 239uy; 0uy; 255uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterCB,[0uy; 0uy; 255uy; 0uy; 239uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterCC,[108uy; 108uy; 236uy; 12uy; 236uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterCD,[0uy; 0uy; 255uy; 0uy; 255uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterCE,[108uy; 108uy; 239uy; 0uy; 239uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterCF,[24uy; 24uy; 255uy; 0uy; 255uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterD0,[108uy; 108uy; 108uy; 108uy; 255uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterD1,[0uy; 0uy; 255uy; 0uy; 255uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterD2,[0uy; 0uy; 0uy; 0uy; 255uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterD3,[108uy; 108uy; 108uy; 108uy; 252uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterD4,[24uy; 24uy; 248uy; 24uy; 248uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterD5,[0uy; 0uy; 248uy; 24uy; 248uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterD6,[0uy; 0uy; 0uy; 0uy; 252uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterD7,[108uy; 108uy; 108uy; 108uy; 255uy; 108uy; 108uy; 108uy]);
        (Pattern.CharacterD8,[24uy; 24uy; 255uy; 24uy; 255uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterD9,[24uy; 24uy; 24uy; 24uy; 31uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterDA,[0uy; 0uy; 0uy; 0uy; 248uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterDB,[255uy; 255uy; 255uy; 255uy; 255uy; 255uy; 255uy; 255uy]);
        (Pattern.CharacterDC,[0uy; 0uy; 0uy; 0uy; 255uy; 255uy; 255uy; 255uy]);
        (Pattern.CharacterDD,[15uy; 15uy; 15uy; 15uy; 15uy; 15uy; 15uy; 15uy]);
        (Pattern.CharacterDE,[240uy; 240uy; 240uy; 240uy; 240uy; 240uy; 240uy; 240uy]);
        (Pattern.CharacterDF,[255uy; 255uy; 255uy; 255uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterE0,[0uy; 0uy; 110uy; 59uy; 19uy; 59uy; 110uy; 0uy]);
        (Pattern.CharacterE1,[62uy; 99uy; 99uy; 51uy; 99uy; 195uy; 115uy; 0uy]);
        (Pattern.CharacterE2,[0uy; 63uy; 51uy; 3uy; 3uy; 3uy; 3uy; 0uy]);
        (Pattern.CharacterE3,[0uy; 0uy; 127uy; 54uy; 54uy; 54uy; 54uy; 0uy]);
        (Pattern.CharacterE4,[63uy; 51uy; 6uy; 12uy; 6uy; 51uy; 63uy; 0uy]);
        (Pattern.CharacterE5,[0uy; 0uy; 126uy; 27uy; 27uy; 27uy; 14uy; 0uy]);
        (Pattern.CharacterE6,[0uy; 102uy; 102uy; 102uy; 102uy; 62uy; 6uy; 3uy]);
        (Pattern.CharacterE7,[0uy; 110uy; 59uy; 24uy; 24uy; 24uy; 24uy; 0uy]);
        (Pattern.CharacterE8,[63uy; 12uy; 30uy; 51uy; 51uy; 30uy; 12uy; 63uy]);
        (Pattern.CharacterE9,[28uy; 54uy; 99uy; 127uy; 99uy; 54uy; 28uy; 0uy]);
        (Pattern.CharacterEA,[28uy; 54uy; 99uy; 99uy; 54uy; 54uy; 119uy; 0uy]);
        (Pattern.CharacterEB,[56uy; 12uy; 24uy; 62uy; 51uy; 51uy; 30uy; 0uy]);
        (Pattern.CharacterEC,[0uy; 0uy; 126uy; 219uy; 219uy; 126uy; 0uy; 0uy]);
        (Pattern.CharacterED,[96uy; 48uy; 126uy; 219uy; 219uy; 126uy; 6uy; 3uy]);
        (Pattern.CharacterEE,[28uy; 6uy; 3uy; 31uy; 3uy; 6uy; 28uy; 0uy]);
        (Pattern.CharacterEF,[30uy; 51uy; 51uy; 51uy; 51uy; 51uy; 51uy; 0uy]);
        (Pattern.CharacterF0,[0uy; 126uy; 0uy; 126uy; 0uy; 126uy; 0uy; 0uy]);
        (Pattern.CharacterF1,[24uy; 24uy; 126uy; 24uy; 24uy; 0uy; 126uy; 0uy]);
        (Pattern.CharacterF2,[6uy; 12uy; 24uy; 12uy; 6uy; 0uy; 63uy; 0uy]);
        (Pattern.CharacterF3,[24uy; 12uy; 6uy; 12uy; 24uy; 0uy; 63uy; 0uy]);
        (Pattern.CharacterF4,[112uy; 216uy; 216uy; 24uy; 24uy; 24uy; 24uy; 24uy]);
        (Pattern.CharacterF5,[24uy; 24uy; 24uy; 24uy; 24uy; 27uy; 27uy; 14uy]);
        (Pattern.CharacterF6,[24uy; 24uy; 0uy; 126uy; 0uy; 24uy; 24uy; 0uy]);
        (Pattern.CharacterF7,[0uy; 110uy; 59uy; 0uy; 110uy; 59uy; 0uy; 0uy]);
        (Pattern.CharacterF8,[28uy; 54uy; 54uy; 28uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterF9,[0uy; 0uy; 0uy; 24uy; 24uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterFA,[0uy; 0uy; 0uy; 0uy; 24uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterFB,[240uy; 48uy; 48uy; 48uy; 55uy; 54uy; 60uy; 56uy]);
        (Pattern.CharacterFC,[26uy; 54uy; 54uy; 54uy; 54uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterFD,[14uy; 25uy; 12uy; 6uy; 31uy; 0uy; 0uy; 0uy]);
        (Pattern.CharacterFE,[0uy; 0uy; 60uy; 60uy; 60uy; 60uy; 0uy; 0uy]);
        (Pattern.CharacterFF,[0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Field,[0x00uy;0x22uy;0x00uy;0x88uy;0x00uy;0x22uy;0x00uy;0x88uy]);
        (Pattern.Tree,[0x10uy;0x10uy;0x38uy;0x38uy;0x7Cuy;0x7Cuy;0xFEuy;0x10uy]);
        (Pattern.Solid,[ 0xFFuy; 0xFFuy; 0xFFuy; 0xFFuy; 0xFFuy; 0xFFuy; 0xFFuy; 0xFFuy]);
        (Pattern.Box,[ 0xFFuy; 0x81uy; 0x81uy; 0x81uy; 0x81uy; 0x81uy; 0x81uy; 0xFFuy]);
        (Pattern.Maze0,[0uy; 0uy; 0uy; 0x18uy; 0x18uy; 0uy; 0uy; 0uy]);
        (Pattern.Maze1,[0x18uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy; 0uy; 0uy; 0uy]);
        (Pattern.Maze2,[0uy; 0uy; 0uy; 0xF8uy; 0xF8uy; 0uy; 0uy; 0uy]);
        (Pattern.Maze3,[0x18uy; 0x18uy; 0x18uy; 0xF8uy; 0xF8uy; 0uy; 0uy; 0uy]);
        (Pattern.Maze4,[0uy; 0uy; 0uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze5,[0x18uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze6,[0uy; 0uy; 0uy; 0xF8uy; 0xF8uy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze7,[0x18uy; 0x18uy; 0x18uy; 0xF8uy; 0xF8uy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze8,[0uy; 0uy; 0uy; 0x1Fuy; 0x1Fuy; 0uy; 0uy; 0uy]);
        (Pattern.Maze9,[0x18uy; 0x18uy; 0x18uy; 0x1Fuy; 0x1Fuy; 0uy; 0uy; 0uy]);
        (Pattern.Maze10,[0uy; 0uy; 0uy; 0xFFuy; 0xFFuy; 0uy; 0uy; 0uy]);
        (Pattern.Maze11,[0x18uy; 0x18uy; 0x18uy; 0xFFuy; 0xFFuy; 0uy; 0uy; 0uy]);
        (Pattern.Maze12,[0uy; 0uy; 0uy; 0x1Fuy; 0x1Fuy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze13,[0x18uy; 0x18uy; 0x18uy; 0x1Fuy; 0x1Fuy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze14,[0uy; 0uy; 0uy; 0xFFuy; 0xFFuy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Maze15,[0x18uy; 0x18uy; 0x18uy; 0xFFuy; 0xFFuy; 0x18uy; 0x18uy; 0x18uy]);
        (Pattern.Empty,[0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.UILeft,[0x3Euy; 0x41uy; 0xc9uy; 0xc5uy; 0xc9uy; 0xc1uy; 0xfeuy; 0x7cuy]);
        (Pattern.UILeftDown,[0uy; 0x7cuy; 0x82uy; 0x92uy; 0x8auy; 0x92uy; 0x82uy; 0x7cuy]);
        (Pattern.UIRight,[0x3Euy; 0x41uy; 0xc9uy; 0xd1uy; 0xc9uy; 0xc1uy; 0xfeuy; 0x7cuy]);
        (Pattern.UIRightDown,[0uy; 0x7cuy; 0x82uy; 0x92uy; 0xa2uy; 0x92uy; 0x82uy; 0x7cuy]);
        (Pattern.UIUp,[0x3Euy; 0x41uy; 0xc9uy; 0xd5uy; 0xc1uy; 0xc1uy; 0xfeuy; 0x7cuy]);
        (Pattern.UIUpDown,[0uy; 0x7cuy; 0x82uy; 0x92uy; 0xaauy; 0x82uy; 0x82uy; 0x7cuy]);
        (Pattern.UIDown,[0x3Euy; 0x41uy; 0xc1uy; 0xd5uy; 0xc9uy; 0xc1uy; 0xfeuy; 0x7cuy]);
        (Pattern.UIDownDown,[0uy; 0x7cuy; 0x82uy; 0x82uy; 0xaauy; 0x92uy; 0x82uy; 0x7cuy]);
        (Pattern.Pin,[0x60uy; 0x70uy; 0x3Euy; 0x1Euy; 0x1cuy; 0x1auy; 0x01uy; 0uy]);
        (Pattern.Energy,[0x78uy; 0x3cuy; 0x1Euy; 0x3fuy; 0x18uy; 0x0cuy; 0x04uy; 0x02uy]);
        (Pattern.Cursor,[0uy; 0uy; 0uy; 0uy; 0x08uy; 0uy; 0uy; 0uy]);
        (Pattern.House,[0x08uy; 0x1cuy; 0x3Euy; 0x7fuy; 0x3Euy; 0x36uy; 0x36uy; 0uy]);
        (Pattern.Door,[0x18uy; 0x3cuy; 0x7Euy; 0x7Euy; 0x7Euy; 0x6euy; 0x7Euy; 0x7Euy]);
        (Pattern.OpenDoor,[0x18uy; 0x24uy; 0x42uy; 0x42uy; 0x42uy; 0x42uy; 0x42uy; 0x7Euy]);
        (Pattern.Wall,[0uy; 0xfeuy; 0xfeuy; 0xfeuy; 0uy; 0xefuy; 0xefuy; 0xefuy]);
        (Pattern.Tagon,[0x1Cuy;0x1Cuy;0x08uy;0x3Euy;0x5Duy;0x1Cuy;0x14uy;0x14uy]);
        (Pattern.DeadTagon,[0x14uy; 0x14uy; 0x1cuy; 0x5duy; 0x3Euy; 0x08uy; 0x1cuy; 0x1cuy]);
        (Pattern.Sapling,[0uy; 0x08uy; 0x08uy; 0x1cuy; 0x08uy; 0x3Euy; 0x08uy; 0uy]);
        (Pattern.Acorn,[0uy; 0uy; 0x10uy; 0x08uy; 0x3Euy; 0x1cuy; 0x08uy; 0uy]);
        (Pattern.Bush,[0uy; 0x3cuy; 0x6euy; 0xfbuy; 0xdfuy; 0x7Euy; 0x18uy; 0x18uy]);
        (Pattern.Berries,[0uy; 0uy; 0x10uy; 0x04uy; 0x20uy; 0uy; 0uy; 0uy]);
        (Pattern.Key,[0uy; 0x1cuy; 0x14uy; 0x1cuy; 0x08uy; 0x0cuy; 0x0cuy; 0uy]);
        (Pattern.Rock,[0uy; 0uy; 0uy; 0x34uy; 0x7Euy; 0x7Euy; 0x3Euy; 0uy]);
        (Pattern.LeftHand,[0x38uy; 0x3cuy; 0x3cuy; 0xbcuy; 0xfcuy; 0x7cuy; 0x3cuy; 0uy]);
        (Pattern.RightHand,[0x1cuy; 0x3cuy; 0x3cuy; 0x3duy; 0x3fuy; 0x3Euy; 0x3cuy; 0uy]);
        (Pattern.Log,[0uy; 0uy; 0x7fuy; 0x3Euy; 0x7fuy; 0uy; 0uy; 0uy]);
        (Pattern.Stone,[0uy; 0uy; 0x38uy; 0x3cuy; 0x3cuy; 0x1cuy; 0uy; 0uy]);
        (Pattern.Axe,[0x12uy; 0x16uy; 0x1Euy; 0x1Euy; 0x16uy; 0x12uy; 0x10uy; 0x10uy]);
        (Pattern.PickAxe,[0x3Euy; 0x49uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy]);
        (Pattern.Shovel,[0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x3Euy; 0x3Euy; 0x1cuy]);
        (Pattern.Hammer,[0x3Euy; 0x3Euy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy]);
        (Pattern.Hoe,[0x0euy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy; 0x08uy]);
        (Pattern.BerrySeed,[0uy; 0uy; 0uy; 0x08uy; 0uy; 0uy; 0uy; 0uy]);
        (Pattern.Pile,[0uy; 0uy; 0uy; 0x14uy; 0x2auy; 0x55uy; 0uy; 0uy]);
        (Pattern.Rabbit,[0uy; 0x04uy; 0x04uy; 0x07uy; 0x7fuy; 0xfcuy; 0x66uy; 0uy]);
        (Pattern.DeadRabbit,[0uy; 0x66uy; 0xfcuy; 0x7fuy; 0x07uy; 0x04uy; 0x04uy; 0uy]);
        (Pattern.Hole,[0uy; 0uy; 0x18uy; 0x3cuy; 0x3cuy; 0x18uy; 0uy; 0uy]);
        (Pattern.Fire,[0x10uy; 0x18uy; 0x0cuy; 0x1cuy; 0x3Euy; 0x3Euy; 0x1cuy; 0uy]);
        (Pattern.Trap,[0uy; 0uy; 0x55uy; 0x55uy; 0x55uy; 0x7fuy; 0uy; 0uy]);
        (Pattern.Knife,[0uy; 0x10uy; 0x18uy; 0x18uy; 0x18uy; 0x10uy; 0x10uy; 0uy]);
        (Pattern.Pelt,[0x18uy; 0x7Euy; 0x3cuy; 0x3cuy; 0x3cuy; 0x3cuy; 0x7Euy; 0x42uy]);
        (Pattern.Meat,[0uy; 0x18uy; 0x3cuy; 0x3cuy; 0x3cuy; 0x3cuy; 0x18uy; 0uy]);
        (Pattern.Selector,[0xc3uy;0x81uy;0uy;0uy;0uy;0uy;0x81uy;0xc3uy]);
        (Pattern.Spear,[0x70uy;0x60uy;0x50uy;0x08uy;0x04uy;0x02uy;0x01uy;0uy]);
        (Pattern.Fish,[0uy;0uy;0x5euy;0x7fuy;0x5euy;0uy;0uy;0uy]);
        (Pattern.Stomach,[0x02uy;0x3euy;0x78uy;0x78uy;0x3euy;0x3fuy;0x01uy;0x00uy]);
        (Pattern.Eye,[0x00uy;0x1cuy;0x36uy;0x6buy;0x36uy;0x1cuy;0x00uy;0x00uy]);
        (Pattern.Mouth,[0x00uy;0x00uy;0x00uy;0x41uy;0x3euy;0x1cuy;0x00uy;0x00uy]);
        (Pattern.Workbench,[0x00uy;0x00uy;0x00uy;0xffuy;0xffuy;0x66uy;0x66uy;0x66uy]);
        (Pattern.Furnace,[0x3cuy;0x7euy;0xe7uy;0xc3uy;0xc3uy;0xc3uy;0xffuy;0xffuy]);
        (Pattern.Bone,[0x00uy;0x30uy;0x70uy;0x78uy;0x1cuy;0x0fuy;0x07uy;0x06uy]);
        (Pattern.Mushroom,[0x3euy;0x7fuy;0x7fuy;0x7fuy;0x00uy;0x1cuy;0x1cuy;0x00uy]);
        (Pattern.Sign,[0x7fuy;0x63uy;0x6fuy;0x67uy;0x7fuy;0x77uy;0x7fuy;0x08uy]);
        (Pattern.Ingot,[0x00uy;0x00uy;0x3cuy;0x7euy;0xffuy;0xffuy;0x00uy;0x00uy])]
        |> Map.ofList
        |> Map.map (fun _ v -> v |> toTextureArray)

    let loadTextures (device:GraphicsDevice) : Map<Pattern,Texture2D>=
        patterns
        |> Map.map (fun _ v -> 
                        let mutable texture = new Texture2D(device,Constants.PatternWidth,Constants.PatternHeight)
                        texture.SetData(v)
                        texture)

